#version 330
#extension GL_ARB_separate_shader_objects : enable





layout(location = 0) in vec3 _vin_Position;
layout(location = 1) in mat4 _vin_MeshTransform;
layout(location = 5) in vec4 _vin_Color;

struct SVertexInput
{
	vec3 Position;
	mat4 MeshTransform;
	vec4 Color;
	int VertexIndex;
	uint InstanceId;
};

layout(location = 0) smooth out vec4 _vout_fragColor;

struct SVertexOutput
{
	vec4 fragColor;
	vec4 VertexPosition;
};

layout( std140) uniform USceneInfo
{
	mat4 ViewProj;
	mat4 View;
	mat4 Proj;
	mat4 InvView;
	mat4 InvViewProj;
	mat4 UserToLHZ;
	mat4 LHZToUser;
	mat4 BillboardingView;
	mat4 PackNormalView;
	mat4 UnpackNormalView;
	vec4 SideVector;
	vec4 DepthVector;
	vec2 ZBufferLimits;
	float Handedness;
} SceneInfo;

layout( std140) uniform UDebugColor
{
	vec4 Color;
} DebugColor;


void VertexMain( in SVertexInput  vInput,  out SVertexOutput  vOutput  )
{


		vec4 pos =  ((vInput.MeshTransform) * (vec4(vInput.Position, 1.0))) ;
		vOutput.VertexPosition =  (( SceneInfo.ViewProj ) * (pos)) ;
	vOutput.fragColor = vInput.Color;
}


void main()
{
	SVertexInput vInput;
	SVertexOutput vOutput;

	vInput.Position = _vin_Position;
	vInput.MeshTransform = _vin_MeshTransform;
	vInput.Color = _vin_Color;
	vInput.VertexIndex = gl_VertexID;
	vInput.InstanceId = uint(gl_InstanceID);
	vOutput.fragColor = vec4(0, 0, 0, 0);
	VertexMain(vInput, vOutput);
	_vout_fragColor = vOutput.fragColor;
	gl_Position = vOutput.VertexPosition;
}
